#include <stdio.h>
#include "fakefibers.h"

void async_resume_from_libev(EV_P_ ev_watcher *w, int revents)
{
	struct async_context *c = w->data;
	c->resume(c);
}

struct bar_ctx {
	struct async_context async;
	ev_timer timer;
	int arg;
};

async_attribute
int do_bar(struct async_context *async)
{
	struct bar_ctx *ctx = container_of(async, struct bar_ctx, async);

	async_start(async);
	
	if (ctx->arg >= 15) {
		fprintf(stderr, "barError\n");
		async_end(0);
	}

	fprintf(stderr, "barA\n");
	async_sleep(&ctx->timer, 1);
	fprintf(stderr, "barB arg=%d\n", ctx->arg);
	async_sleep(&ctx->timer, 2);

	async_end(42);
}

#define bar(_ctx, arg1) ({ \
	struct bar_ctx *__ctx = (_ctx);		\
	__ctx->arg = arg1;			\
	async_call(do_bar, &(_ctx)->async); })

struct foo_ctx {
	struct async_context async;
	struct bar_ctx bar;
	ev_timer timer;
};

async_attribute
int foo(struct async_context *async)
{
	struct foo_ctx *ctx = container_of(async, struct foo_ctx, async);
	int rc;

	async_start(async);

	fprintf(stderr, "A\n");
	async_sleep(&ctx->timer, 1);
	fprintf(stderr, "B\n");
	async_sleep(&ctx->timer, 2);

	rc = bar(&ctx->bar, 10);
	fprintf(stderr, "bar=%d\n", rc);

	rc = bar(&ctx->bar, 20);
	fprintf(stderr, "bar=%d\n", rc);

	async_sleep(&ctx->timer, 3);
	fprintf(stderr, "D\n");

	async_end(0);
}

int main(void)
{
	struct foo_ctx ctx;

	ev_default_loop(0);
	async_launch(foo, &ctx.async);
	ev_run(EV_DEFAULT, 0);
	ev_default_destroy();

	return 0;
}
